/***************************************************************************
**+----------------------------------------------------------------------+**
**|                                ****                                  |**
**|                                ****                                  |**
**|                                ******o***                            |**
**|                          ********_///_****                           |**
**|                           ***** /_//_/ ****                          |**
**|                            ** ** (__/ ****                           |**
**|                                *********                             |**
**|                                 ****                                 |**
**|                                  ***                                 |**
**|                                                                      |**
**|     Copyright (c) 2006 - 2008    Texas Instruments Incorporated      |**
**|                        ALL RIGHTS RESERVED                           |**
**|                                                                      |**
**| Permission is hereby granted to licensees of Texas Instruments       |**
**| Incorporated (TI) products to use this computer program for the sole |**
**| purpose of implementing a licensee product based on TI products.     |**
**| No other rights to reproduce, use, or disseminate this computer      |**
**| program, whether in part or in whole, are granted.                   |**
**|                                                                      |**
**| TI makes no representation or warranties with respect to the         |**
**| performance of this computer program, and specifically disclaims     |**
**| any responsibility for any damages, special or consequential,        |**
**| connected with the use of this program.                              |**
**|                                                                      |**
**+----------------------------------------------------------------------+**
***************************************************************************/

/*! \file crc32.h
    \brief CRC32 implementation header file
*/

#include "sys_types.h"

/**************************************************************************/
/*! \fn Uint32 crc32( Uint32 crc, const Uint8 *buf, Uint32 len )
**************************************************************************
 *  \brief  CRC32 implementation
 *  \param[in] crc: Initial CRC
 *  \param[in] buf: Pointer to data buffer
 *  \param[in] len: Buffer length
 *  \return CRC32 value
  **************************************************************************/
Uint32 crc32( Uint32 crc, const Uint8 *buf, Uint32 len );

